# dmxcommon.c File Reference

`#include "dmxinputinit.h"`
`#include "dmxcommon.h"`
`#include "dmxconsole.h"`
`#include "dmxprop.h"`
`#include "dmxsync.h"`
`#include "dmxmap.h"`
`#include "inputstr.h"`
`#include "input.h"`
`#include "keysym.h"`
`#include "mipointer.h"`
`#include "scrnintstr.h"`
`#include <unistd.h>`

## Data Structures

struct | _myPrivate

## Typedefs

typedef _myPrivate | myPrivate

## Functions

void | dmxCommonKbdCtrl (DevicePtr pDev, KeybdCtrl *ctrl)
void | dmxCommonMouCtrl (DevicePtr pDev, PtrCtrl *ctrl)
void | dmxCommonKbdBell (DevicePtr pDev, int percent, int volume, int pitch, int duration)
void | dmxCommonKbdGetMap (DevicePtr pDev, KeySymsPtr pKeySyms, CARD8 *pModMap)
void | dmxCommonKbdGetInfo (DevicePtr pDev, DMXLocalInitInfoPtr info)
int | dmxCommonKbdOn (DevicePtr pDev)
void | dmxCommonKbdOff (DevicePtr pDev)
int | dmxCommonOthOn (DevicePtr pDev)
void | dmxCommonOthOff (DevicePtr pDev)
void | dmxCommonOthGetInfo (DevicePtr pDev, DMXLocalInitInfoPtr info)
void | dmxCommonMouGetMap (DevicePtr pDev, unsigned char *map, int *nButtons)
int | dmxCommonMouOn (DevicePtr pDev)
void | dmxCommonMouOff (DevicePtr pDev)
int | dmxFindPointerScreen (int x, int y)
pointer | dmxCommonCopyPrivate (DeviceIntPtr pDevice)
void | dmxCommonSaveState (pointer private)
void | dmxCommonRestoreState (pointer private)

## Detailed Description

This file implements common routines used by the backend and console input devices.

## Typedef Documentation

typedef struct _myPrivate myPrivate

| Each device has a private area that is visible only from inside the driver code.

## Function Documentation

pointer dmxCommonCopyPrivate | ( | DeviceIntPtr | pDevice | ) |

| Returns a pointer to the private area for the device that comes just prior to pDevice in the current dmxInput device list. This is used as the private area for the current device in some situations (e.g., when a keyboard and mouse form a pair that should share the same private area). If the requested private area cannot be located, then NULL is returned.

void dmxCommonKbdBell | ( | DevicePtr | pDev,
|  | int | percent,
|  | int | volume,
|  | int | pitch,
|  | int | duration
| ) |

| Sound they keyboard bell.

void dmxCommonKbdCtrl | ( | DevicePtr | pDev,
|  | KeybdCtrl * | ctrl
| ) |

| Update the keyboard control.

void dmxCommonKbdGetInfo | ( | DevicePtr | pDev,
|  | DMXLocalInitInfoPtr | info
| ) |

| Fill in the XKEYBOARD parts of the info structure for the specified pDev.

void dmxCommonKbdGetMap | ( | DevicePtr | pDev,
|  | KeySymsPtr | pKeySyms,
|  | CARD8 * | pModMap
| ) |

| Get the keyboard mapping.

void dmxCommonKbdOff | ( | DevicePtr | pDev | ) |

| Turn pDev off.

int dmxCommonKbdOn | ( | DevicePtr | pDev | ) |

| Turn pDev on (i.e., take input from pDev).

void dmxCommonMouCtrl | ( | DevicePtr | pDev,
|  | PtrCtrl * | ctrl
| ) |

| Update the mouse control.

void dmxCommonMouGetMap | ( | DevicePtr | pDev,
|  | unsigned char * | map,
|  | int * | nButtons
| ) |

| Obtain the mouse button mapping.

void dmxCommonMouOff | ( | DevicePtr | pDev | ) |

| Turn pDev off.

int dmxCommonMouOn | ( | DevicePtr | pDev | ) |

| Turn pDev on (i.e., take input from pDev).

void dmxCommonOthGetInfo | ( | DevicePtr | pDev,
|  | DMXLocalInitInfoPtr | info
| ) |

| Fill the info structure with information needed to initialize pDev.

void dmxCommonOthOff | ( | DevicePtr | pDev | ) |

| Turn pDev off.

int dmxCommonOthOn | ( | DevicePtr | pDev | ) |

| Turn pDev on (i.e., take input from pDev).

void dmxCommonRestoreState | ( | pointer | private | ) |

| This routine restores all the information saved by dmxCommonSaveState.

void dmxCommonSaveState | ( | pointer | private | ) |

This routine saves and resets some important state for the backend and console device drivers:

- the modifier map is saved and set to 0 (so DMX controls the LEDs)
- the key click, bell, led, and repeat masks are saved and set to the values that DMX claims to be using

This routine and dmxCommonRestoreState are used when the pointer enters and leaves the console window, or when the backend window is active or not active (for a full-screen window, this only happens at server startup and server shutdown).

int dmxFindPointerScreen | ( | int | x,
|  | int | y
| ) |

| Given the global coordinates x and y, determine the screen with the lowest number on which those coordinates lie. If they are not on any screen, return -1. The number returned is an index into #dmxScreenInfo and is between -1 and dmxNumScreens - 1, inclusive.

Generated June 29, 2004 for Distributed Multihead X by doxygen 1.3.4. </addres>